//---------------------------------------------------------------------------
#ifndef IvoryMapperH
#define IvoryMapperH
//---------------------------------------------------------------------------
#include "IvoryDraw.h"
class TIvorySurface;

class IVORY_package TIvoryMapper : public TComponent
{
private:
	int FTileWidth;
   int FTileHeight;
	int FTiles;
   int FTileRows;
   int FTileColumns;
   TIvorySurface* FSurface;
protected:
	int __fastcall GetTileRows() const;
   int __fastcall GetTileColumns() const;
   TRect __fastcall GetTileRect(int n) const;
   void __fastcall SetBitmap(TIvoryBitmap* bitmap);
   TIvoryBitmap* __fastcall GetBitmap() const;
   void __fastcall SetTransparent(bool transparent);
   bool __fastcall GetTransparent() const;
   void __fastcall SetTransparentColor(int color);
   int __fastcall GetTransparentColor() const;
public:
	__fastcall TIvoryMapper(Classes::TComponent* AOwner);
	__fastcall ~TIvoryMapper();

	__property int TileRows = { read=FTileRows };
	__property int TileColumns = { read=FTileColumns };
   __property TRect TileRect[int n] = { read=GetTileRect };
   __property TIvorySurface* Surface = { read=FSurface };
__published:
	__property int TileWidth = { read=FTileWidth, write=FTileWidth, default=0 };
	__property int TileHeight = { read=FTileHeight, write=FTileHeight, default=0 };
   __property int Tiles = { read=FTiles, write=FTiles, default=0 };
   __property TIvoryBitmap* Bitmap = { read=GetBitmap, write=SetBitmap, default=NULL };
   __property bool Transparent = { read=GetTransparent, write=SetTransparent, default=false };
   __property int TransparentColor = { read=GetTransparentColor, write=SetTransparentColor, default=0 };
};
//---------------------------------------------------------------------------
#endif
